
#include 	<stdio.h>
#include 	<malloc.h>
#include	<string.h>
#include        "global_var.h"
#include	"basic_fun.h"


//
//generate a temporary variable by given type and in given statement block
//
SgVariableSymb	*get_temp_variable(SgStatement *hedr_stmt,SgType *type,char *idstr)
{	char	str[60];
	SgVariableSymb	*sym;
	SgStatement	*last_decl=hedr_stmt->lastDeclaration();
	sprintf(str,"%sTV%d",idstr,++index_var);
	sym=new SgVariableSymb(str,*type,*hedr_stmt);
	return(sym);
}
//
//initilize index_g and index_var
//
void	init_temp_index(SgStatement *hedr_stmt)
{
	index_g=-1;
	index_var=-1;
}
//
//get index variable used in forall header
//
SgVariableSymb	*get_temp_index(int i,SgStatement *hedr_stmt,char *idstr)
{	SgVariableSymb	*sym;
	char 	str[60];

	if (i>index_g) {
		sprintf(str,"%sTI%d",idstr,i);
                sym=new SgVariableSymb(str,*hedr_stmt);
		SgStatement * decl_stmt;
                decl_stmt=sym->makeVarDeclStmt();
		SgStatement  *last_decl=hedr_stmt->lastDeclaration();
                last_decl->insertStmtAfter(*decl_stmt,*hedr_stmt);
//                sym->declareTheSymbol(*hedr_stmt);
                temp_index[i]=sym;
		index_g=i;
	}
	return temp_index[i];
}
